<!DOCTYPE html>
<html xmlns:MadCap="http://www.madcapsoftware.com/Schemas/MadCap.xsd" lang="en-us" xml:lang="en-us" class="no-feedback" data-mc-search-type="Stem" data-mc-help-system-file-name="index.xml" data-mc-path-to-help-system="../../" data-mc-target-type="WebHelp2" data-mc-runtime-file-type="Topic" data-mc-preload-images="false" data-mc-in-preview-mode="false" data-mc-toc-path="Task Chains">
    <head>
        <meta charset="utf-8" />
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><title>Managing and Editing Task Chains</title>
        
        <link href="../../Skins/Default/Stylesheets/TextEffects.css" rel="stylesheet" />
        <link href="../../Skins/Default/Stylesheets/Topic.css" rel="stylesheet" />
        <link href="../Resources/Stylesheets/Styles.css" rel="stylesheet" />
        <script src="../../Resources/Scripts/jquery.min.js">
        </script>
        <script src="../../Resources/Scripts/plugins.min.js">
        </script>
        <script src="../../Resources/Scripts/MadCapAll.js">
        </script>
    </head>
    <map id="map1" name="map1">
        <area shape="rectangle" coords="840,44,1093,87" href="http://www.rapid7.com/products/metasploit/download.jsp" target="_blank" />
        <area shape="rectangle" coords="1107,48,1211,80" href="http://www.rapid7.com/products/metasploit/" target="_blank" />
    </map>
    <body>
        <p class="MCWebHelpFramesetLink MCWebHelpFramesetLinkTop" style="display: none;"><a href="../../index.html#12-task-chains/managing-and-editing-task-chains.html">Open topic with navigation</a>
        </p>
        <h1>Managing and Editing Task Chains</h1>
        <p>Task chains are a series of preconfigured tasks that execute in sequential order. They are editable, cloneable, and suspendable, which makes it easy for you to manage and reuse task chains. For example, if you have an existing task chain that you want to reuse  with a slightly different configuration, you can clone and customize that task chain.</p>
        <h2><a name="Editing"></a>Editing a Task Chain </h2>
        <p>You can edit a task chain to modify its existing settings. To edit a task chain, select <b class="UISelection">Tasks &gt; Chains</b> from the Project tab bar.</p>
        <p>When the Task Chains list appears, click on the name of the task chain that you want to edit. </p>
        <p>
            <img src="../Resources/Images/task-chains/task-chains-name-link_496x142.png" title="Task chains list" alt="Task chains list" style="width: 496;height: 142;" />
        </p>
        <p>When the task chain configuration page opens, you can do things like add, clone, and remove tasks; tweak settings for a particular task; and update the schedule for the task chain. </p>
        <p>
            <img src="../Resources/Images/task-chains/task-chains-config-page-2_513x273.png" title="Task chain configuration page" alt="Task chain configuration page" style="width: 513;height: 273;" />
        </p>
        <h2><a name="Cloning"></a>Cloning a Task Chain
</h2>
        <p>
When you clone a task chain, you are making a copy of it. Cloning enables you to reuse an existing task chain configuration. For example, you may want to clone a task chain if you want to run the same task chain on a different schedule or if you want to run a task chain with slight modifications.</p>
        <p>To clone a task chain, select <b class="UISelection">Tasks &gt; Chains</b> from the Project tab bar.</p>
        <p>When the Task Chains list appears, select the task chain that you want to clone. </p>
        <p>
            <img src="../Resources/Images/task-chains/task-chains-select-chain_494x145.png" style="width: 494;height: 145;">
            </img>
        </p>
        <p>Click the <b class="UISelection">Clone</b> button. </p>
        <p>
            <img src="../Resources/Images/task-chains/task-chains-clone-button-2_486x142.png" title="Clone task chain" alt="Clone task chain" style="width: 486;height: 142;">
            </img>
        </p>
        <p>The task chain configuration form appears.&#160;The form retains the configuration settings that you used to create the original task chain. You can run the task chain as is, or you can modify its settings. </p>
        <p>The cloned task chain will use the following naming convention: <code>[task-chain-name]-timestamp</code>. </p>
        <h2><a name="Suspendi"></a>Suspending a Task Chain </h2>
        <p>You can suspend a task chain if you want the task chain to ignore its current schedule. When you suspend a task chain, it will not run again until you re-enable the schedule or manually run it yourself.</p>
        <p class="Note" data-mc-autonum="&lt;b&gt;Note:&lt;/b&gt; &#160;"><span class="autonumber"><span><b>Note:</b> &#160;</span></span>When you suspend a running task chain, the task chain will be canceled. Do not suspend a running task chain unless you intend to stop it. </p>
        <p>To suspend a task chain, select <b class="UISelection">Tasks &gt; Chains</b> from the Project tab bar. </p>
        <p>When the Task Chains list appears, select the task chain whose schedule you want to suspend. The task chain that you select must be scheduled and in an unsuspended state. These task chains will have a scheduled icon located next to them.</p>
        <p class="Note" data-mc-autonum="&lt;b&gt;Note:&lt;/b&gt; &#160;"><span class="autonumber"><span><b>Note:</b> &#160;</span></span>If you need to bulk suspend task chains, you can select multiple task chains.</p>
        <p>
            <img src="../Resources/Images/task-chains/task-chains-select-chain-2_553x165.png" title="Task chains list" alt="Task chains list" style="width: 553;height: 165;" />
        </p>
        <p>Click the <b class="UISelection">Suspend</b> button. </p>
        <p>
            <img src="../Resources/Images/task-chains/task-chains-suspend-button_552x165.png" title="Suspend button" alt="Suspend button" style="width: 552;height: 165;" />
        </p>
        <p>The schedule icon changes to the suspended icon. </p>
        <p>
            <img src="../Resources/Images/task-chains/task-chains-suspend-icon_555x182.png" title="Task Chains List" alt="Task Chains List" style="width: 555;height: 182;" />
        </p>
        <p>To unsuspend a task chain, select it and click the <b class="UISelection">Unsuspend</b> button. The task chain you selected must be in a suspended state. <img src="../Resources/Images/task-chains/task-chains-unsuspend-button_533x176.png" title="Task Chains List" alt="Task Chains List" style="width: 533;height: 176;" /></p>
        <h2><a name="Updating"></a>Updating the Schedule for a Task Chain </h2>
        <p>To edit the schedule for an existing task chain, select <b class="UISelection">Tasks &gt; Chains</b> from the Project tab bar.</p>
        <p>When the Task Chains list appears, click on the name of the task chain whose schedule you want to edit. </p>
        <p>
            <img src="../Resources/Images/task-chains/task-chains-name-link_496x142.png" title="Task chains list" alt="Task chains list" style="width: 496;height: 142;">
            </img>
        </p>
        <p>When the task chain configuration page opens, click on the <b class="UISelection">Schedule Now</b> link to open the scheduler. </p>
        <p>
            <img src="../Resources/Images/task-chains/task-chains-schedule-now-link_545x95.png" title="Schedule now link" alt="Schedule now link" style="width: 545;height: 95;">
            </img>
        </p>
        <p>The scheduler will display the current schedule. You can use the scheduler to update the existing settings.</p>
        <h2>Stopping a Running Task Chain  </h2>
        <p>To cancel a running task chain, select <b class="UISelection">Tasks &gt;&#160;Chains</b> from the Project tab bar. </p>
        <p>Select the running task chain you want to cancel and click the <b class="UISelection">Stop</b> button. A running task chain will show a running icon in the <b class="UISelection">Status</b> column. </p>
        <p>
            <img src="../Resources/Images/task-chains/task-chains-stop_521x140.png" style="width: 521;height: 140;" />
        </p>
        <p>Any data that was collected before you stopped the tasks will still be stored in the project. </p>
        <h2><a name="Stopping2"></a>Stopping All Running Tasks</h2>
        <p>To stop all tasks that are currently running in <span class="VariablesProductName">Metasploit Pro</span>, select <b class="UISelection">Administration &gt; Global Settings</b>. Scroll down to the bottom of the page and find the <b class="UISelection">Stop all tasks</b> button. This will immediately stop all active tasks. Please alert your other team members if you intend to cancel their running tasks. </p>
        <p>
            <img src="../Resources/Images/task-chains/task-chains-stop-tasks_272x49.png" title="Stop all tasks" alt="Stop all tasks" style="width: 272;height: 49;">
            </img>
        </p>
        <p>Any data that was collected before you stopped the tasks will still be stored in the project. </p>
        <h2><a name="Viewing"></a>Viewing  the Tasks Log </h2>
        <p>The Tasks Log shows you the events for a particular task. To view the task log for a task,  select <b class="UISelection">Tasks &gt; Show Tasks</b> from the Project tab bar.</p>
        <p>When the task log appears, find and click on the task you want to view. </p>
        <p>
            <img src="../Resources/Images/task-chains/task-chains-task-log_568x109.png" style="width: 568;height: 109;" />
        </p>
        <p>The Tasks Log appears and shows you the status and activity for the task. </p>
        <p>
            <img src="../Resources/Images/task-chains/task-chains-task-log-2_563x231.png" title="Tasks Log" alt="Tasks Log" style="width: 563;height: 231;" />
        </p>
        <h2><a name="Cleaning"></a>Cleaning Up Open Sessions </h2>
        <p>A task chain that includes a task like bruteforce, exploit, or module run may open a session on the target system. An open session enables you to interact with the compromised system. When you are done with a session, you should close the connection with the target. </p>
        <p>To clean up and close open sessions, you should add a clean up task to the task chain. As a rule of thumb, the clean up task should be the last task in the task chain. This ensures that has the opportunity to collect system information and take advantage of open sessions before it closes them.</p>
        <h2>Deleting a Task Chain</h2>
        <p>When you delete a task chain, it will be permanently removed from the project, and you will no longer be able to access or run it. You will not be able to recover a deleted task chain. </p>
        <p>To delete a task chain, select <b class="UISelection">Tasks &gt; Chains</b> from the Project tab bar.</p>
        <p>When the Task Chains list appears, select the task chain that you want to delete. </p>
        <p>
            <img src="../Resources/Images/task-chains/task-chains-select-chain_494x145.png" style="width: 494;height: 145;">
            </img>
        </p>
        <p>Click the <b class="UISelection">Delete</b> button. </p>
        <p>
            <img src="../Resources/Images/task-chains/task-chains-delete-button-2_500x148.png" title="Delete button" alt="Delete button" style="width: 500;height: 148;" />
        </p>
    </body>
</html>